<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 7, 2002
// by:  Mike Agar
//      myh_support@jmagar.com 
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
// Requirements:
// ~~~~~~~~~~~~~~~~
//	- MySQL v3.23.23 and greater is required. 
//	- MySQL connection must be established before calling "init()" 
//
//

global $myhPath; //this must be set before including this file!!!
global $myh_is_included;
$myh_is_included=1;

//Data Classes
include_once ("$myhPath/include/gtu.php");
include_once ("$myhPath/include/pd.php");
include_once ("$myhPath/include/act.php");
include_once ("$myhPath/include/src.php");
include_once ("$myhPath/include/cat.php");
include_once ("$myhPath/include/cache.php");
include_once ("$myhPath/include/stck.php");
include_once ("$myhPath/include/SOAPx4/class.soap_client.php");

//Utility Classes
include_once ("$myhPath/include/scraper.php");

//MyHeadlines Core Functionality Objects
include_once ("$myhPath/core/install.php");
include_once ("$myhPath/core/user.php");
include_once ("$myhPath/core/rss.php");
include_once ("$myhPath/core/admin.php");
include_once ("$myhPath/core/stock_ticker.php");

class MyHeadlines {
	//data classes
	var $gtu;
	var $pd;
	var $act;
	var $cat;
	var $cache;
	var $src;
	var $stck;
	var $menuHeaders;
	var $menuURL;
	
	//CMS Abstratcion Layer
	var $prefixURL;

	//State Machine
	var $MYH_DEBUG;
	var $myhLang;
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//CMS Abstraction Layer
	
	function MYH_INIT($url, $table_name_prefix="AGAR", $isAdmin=0, $externalUID=0, $userName=0, $DBG=0){
		
		global $myhPath;
		
		//init internal vars
		$this->MYH_DEBUG = $DBG;
		$this->prefixURL = $url;

		//init the PD (configuration class)
		$this->pd = new agar_pd;
		$this->pd->PD_INIT("$table_name_prefix"."_myh_pd",$this->MYH_DEBUG);

		//make sure the PD is populated with defaults
		$install = new myh_install;
		$install->Install($this->pd,$this->MYH_DEBUG);
		
		//init all other data classes
		$this->gtu = new agar_gtu;
		$this->gtu->GTU_INIT("$table_name_prefix"."_myh_gtu");

		$this->act = new agar_act;
		$this->act->ACT_INIT("$table_name_prefix"."_myh_act",$this->MYH_DEBUG);
		$this->act->initUser($isAdmin,$externalUID,$userName);

		$this->cache = new agar_cache;
		$this->cache->CACHE_INIT("$table_name_prefix"."_myh_cache",$this->MYH_DEBUG,$this->pd->getValue("rss_cache_expire"));

		$this->cat = new agar_cat;
		$this->cat->CAT_INIT("$table_name_prefix"."_myh_cat",$this->MYH_DEBUG);

		$this->src = new agar_src;
		$this->src->SRC_INIT("$table_name_prefix"."_myh_src",$this->MYH_DEBUG);

		$this->stck = new agar_stck;
		$this->stck->STCK_INIT("$table_name_prefix"."_myh_stck",$this->MYH_DEBUG);

		$this->myhLang = array();
		$langFile = $this->pd->getValue("default_lang");
		if($langFile==0)$langFile = "not_yet_set";

		if(file_exists($langFile)){
			$fd = fopen ($langFile, "r");
			$contents = fread ($fd, filesize ($langFile));
			fclose ($fd);
			eval($contents);
		}else{
			$this->pd->setValue("default_lang",$myhPath."/lang/english_lang.php");
			$langFile = $this->pd->getValue("default_lang");
			$fd = fopen ($langFile, "r");
			$contents = fread ($fd, filesize ($langFile));
			fclose ($fd);
			eval($contents);
		}
		$this->menuHeaders = array();
		$this->menuURL = array();
		
		$this->preProcessor();
	}

	function registerMenuURL($header,$text,$url){
		$this->menuHeaders[$header]=$header;
		$this->menuURL[$header]["text"][] = $text; 	
		$this->menuURL[$header]["url"][] = $url; 	
	}
	
	function showGUI(){
		global $myh;
		
		$menu = new myh_menu($this->pd,$this->gtu,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
		//////////////////////////////////////////////////////////////////////
		// Main Menu Interface
		$output =  "<table border=\"1\" width=\"100%\" valign=\"top\">\n";
		$output .=  "<tr><td valign=\"top\"><b><center>".$this->myhLang["Menu"]."</center></b></td><td width=100% colspan=2></td></tr><tr><td valign=\"top\">\n";//always show menu...
		$output .= $menu->showMenu($this->gtu,$this->act);
		//Process Menu Headers / URLs
		$h_end = count($this->menuHeaders);
		$keys = array_keys($this->menuHeaders);
		for($hLoop=0;$hLoop<$h_end;$hLoop++){
			$output .= "<table><tr><td><nobr><b>".$this->menuHeaders[$keys[$hLoop]]."</b></nobr></td></tr>";
			$u_end = count($this->menuURL[$this->menuHeaders[$keys[$hLoop]]]["text"]);
			for($uLoop=0;$uLoop<$u_end;$uLoop++){
				$output .= "<tr><td><nobr><a href=";
				$output .= $this->menuURL[$this->menuHeaders[$keys[$hLoop]]]["url"][$uLoop];
				$output .= ">".$this->menuURL[$this->menuHeaders[$keys[$hLoop]]]["text"][$uLoop];
				$output .= "</a></nobr></td></tr>";
			}
			$output .= "</table>";
		}	
		$output .= "</td><td width=100% valign=\"center\">\n";
		//////////////////////////////////////////////////////////////////////
		// Post Process Core Actions (display screens/whatever...)
		$code = "\$code_dummy_var = 1;";
		$fp = 0; //Front Page Flag...
		switch ($myh){
			case "user":
				$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$code = $user->getScreenCode();
				break;
			case "admin":
				$admin = new myh_admin($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$user = &$admin;
				$code = $admin->getScreenCode();
				break;
			case "menu":
				$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$code = $menu->getScreenCode();
				break;
			default:
				//This must be the front page...
				$fp = 1;
				break;
		}

		if($fp){
			//should we show the stock ticker box?
			$output .= $this->pd->getValue("front_page");
			$subs = $this->getSubs("st");
			if(count($subs)>0||1){
				$output .= "</td><td>";
				$stocks = new myh_stock($this->pd);
				
				$box = $stocks->myhStockBox($this->pd,$this->stck,$this->myhLang,$subs,$this->prefixURL);
				$output .= $box["content"];
			}
		}else{
			eval($code);
			$output .= "<hr>\n";
			$output .= $this->myhResetButton($this->myhLang["Done"]);
		}
		
		$output .= "</td></tr></table>\n";
		return $output;
	}

	function getSubs($place){
		/************************************************
		place can be one of:
			lt = Top Left
			lb = Bottom Left
			rt = Top Right
			rb = Bottom Right
			ct = Top Center
			cb = Bottom Center
			st = Stock Subscriptions
		**************************************************/
		if($this->MYH_DEBUG)echo "getSubs($place): start<br>\n";
		$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
		$subs = $user->userTree->getSubscriptions($this->gtu,$this->act,$user->userTree->myh_user_place[$place]);
		$mand = $user->userTree->getSubscriptions($this->gtu,$this->act,$user->userTree->myh_user_place[$place],1);
		$subs = array_merge($subs,$mand);
		if($this->MYH_DEBUG){
			$count = count($subs);
			echo "getSubs($place): (count = $count) end<br>\n";
		}
		return $subs; 
	}


	function getCache($sd, $show_desc=0, $show_all=0, $show_date=0){
		//TODO: Implement the show date feature
		global $myhPath;
		$rtn=array();
		//get src specific info
		$rtn["title"]=$this->src->getTitle($sd);
		$rtn["image"] = $this->src->getImage($sd);
		$rtn["content"] = "";
		//get the items
		$not_done = $this->pd->getValue("rss_max_items");
		$items = $this->cache->getItems($sd,$url);
		$dFormat = $this->pd->getValue("date_format");
		$rtn["content"] .= "<table cellpadding=2 cellspacing=0>";
		while(list($cid,$iser, $timeout) = @current($items)){
			if($not_done||$show_all){
				$item = unserialize($iser);
				if($this->MYH_DEBUG){
					$icnt++;
					echo "getCT(): ($icnt) $item->title<br>\n";
				}
				//TODO: Content should be a table
				//TODO: Content should enable "Dynamic Button" EX - "Promote" feature in CMS like PostNuke...
				$item->link = $this->getClickThruURL($cid);
				//bullet
				$rtn["content"] .= "<tr>";
				$rtn["content"] .= "<td valign=top><img src=".$myhPath."/images/bullet.gif></td>";
				//link
				$rtn["content"] .= "<td width=100% valign=top ><a href=".$item->link." target=_blank>".$this->unscrub($item->title)."</a>";
				if($this->pd->getValue("rss_show_summary")||$show_desc){
					if(strlen($item->description)>2)$rtn["content"] .= "<br>".$this->unscrub($item->description)."\n";	
				}
				$rtn["content"] .= "</td></tr>\n";
			}else{
				$more  = "<tr><td></td><td align=right><a href=";
				$more .= $this->prefixURL;
				$more .= "&myh=user&myh_op=show_all&eid=";
				$more .= $sd;	
				$more .= ">".$this->myhLang["more_like_this"]."</a></td></tr></table>\n";
	
				$rtn["content"]  .= $more;
				return $rtn;
			}
			$not_done--;
			next($items);
		}
		$rtn["content"] .= "</table>";
	 	return $rtn;
	}

	function getStats($horizontal=0){//if you want it horzontal (main menu) set this to 1
	
		$csize = $this->cache->countAll();
		$src_stale = count($this->src->listStale());
		$subs = $this->src->subsCount();
		$items = $this->cache->hitsCount();
		$srcCount  = count($subs);
		$sources = $this->src->srcCount();
		//misc
		if($horizontal)$rtn .= "<table width=95%><tr><td colspan=2>";
		$rtn .= "<nobr>".$this->myhLang["cache_size"].": <b>$csize</b></nobr><br>\n";
		$rtn .= "<nobr>".$this->myhLang["total_srcs"].": <b>$sources</b></nobr><br>\n";
		$rtn .= "<nobr>".$this->myhLang["active_srcs"].": <b>$srcCount</b></nobr><br>\n";
		$rtn .= "<nobr>".$this->myhLang["expired_srcs"].": <b>$src_stale</b></nobr><br>\n";
		if($horizontal)$rtn .= "</td></tr><tr><td>";
		//top ten srcs
		$rtn .= "<p><table border=0 cellspacing=0 cellpadding=1><tr><td colspan=2><b>".$this->myhLang["top_srcs"].":</b></td></tr>";
		$keys = array_keys($subs);
		$end = count($keys);
		for($loop=0;$loop<$end;$loop++){
			$title = $this->src->getTitle($keys[$loop]);
			$url = $this->prefixURL."&myh=user&myh_op=show_all&eid=".$keys[$loop];
			$rtn .= "<tr><td valign=top align=right><b>".($loop+1)."</b>)</td><td valign=top><a href=$url>$title</a>";
			if($this->act->isAdmin)$rtn .= " (".$subs[$keys[$loop]].")";
			$rtn .= "</td></tr>";
			if($loop==9)$loop=$end;//break out at 10 (top ten)
		}
		$rtn .= "</table>";
		if($horizontal)$rtn .= "</td><td>";
		//top ten stories
		$rtn .= "<p><table border=0 cellspacing=0 cellpadding=1><tr><td colspan=2><b>".$this->myhLang["top_items"].":</b></td></tr>";
		$keys = array_keys($items);
		$end = count($keys);
		for($loop=0;$loop<$end;$loop++){
			$item = unserialize($this->cache->getItem($keys[$loop]));
			$title = $item->title;
			$url = $this->prefixURL."&myh=user&myh_op=click&cid=".$keys[$loop];
			$rtn .= "<tr><td valign=top align=right><b>".($loop+1)."</b>)</td><td valign=top><a href=$url target=_blank>$title</a>";
			if($this->act->isAdmin)$rtn .= " (".$items[$keys[$loop]].")";
			$rtn .= "</td></tr>";
			if($loop==9)$loop=$end;//break out at 10 (top ten)
		}
		$rtn .= "</table>";
		if($horizontal)$rtn .= "</td></tr></table>";			
		return $rtn;
	
	}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//State Macine Functions
	
	function updateCache($sd){
		$image_hr = 0; //underline image with <hr>?
		$catTree = new myh_cat_tree($this->MYH_DEBUG);
		if(!($catTree->isGoodSrc($this->pd,$this->gtu,$sd))){
			$this->src->touch($sd);
			return; //Head Nurse Looked up and said, "Leave that one alone..."
			        //  - (sorry, listening to George Thorogood right now...)
		}
		if($this->src->isStale($sd)){
			//reset timeout clock on this src first.  You get one try at it!  
			//if this hangs it will not hold up other cron cycles (until it expires again...)
			$this->src->touch($sd); 

			$rss = new myh_rss($this->pd,$this->MYH_DEBUG);
			
			//go get this src's file...
			$url = $this->src->getURL($sd);
			$file = $rss->getRSS($this->pd,$url);
			$image = "";
			if(!$file){
				if($rss->MYH_DEBUG)echo "Connection has Failed<br>\n";
				//   thoughts: - change the timeout for the src to a large number 2 days?
				//   TODO:     - clear this src's cache, and insert an appropriate error message
				if($this->pd->getValue("show_shameless_plug")){
					$image =  	$this->pd->getValue("rss_pow_img");
					if($image_hr)$image .= "<hr>\n";
				}else{
					$image = "";
				}
				$this->src->setImage($sd,$image);
				$catTree->badSrc($this->pd,$this->gtu,$this->src,$sd);
			}else{
				$catTree->goodSrc($this->pd,$this->gtu,$this->src,$sd);
				if($rss->MYH_DEBUG)echo "updateCache(): Connection and retrieval completed<br>\n";
				$channel = $rss->rssParsePage($file);
				if($rss->MYH_DEBUG) echo "updateCache(): ".$channel["title"]."<br>\n";
				//Update Src Image Info
				if(strlen($channel["link"])>4){
					$image .= "<a href=".$channel["link"]." target=_blank>";
				}
				if(strlen($channel["image"])>4){
					if($this->pd->getValue("rss_override_logo_width")){
						$logo_width = $this->pd->getValue("rss_logo_width");
						$image .= "<img src=".$channel["image"]." width=$logo_width>";
					}else{
						$image .= "<img src=".$channel["image"].">";
					}
					if(strlen($channel["link"])>4){
						$image .= "</a>";
					}
					if($image_hr)$image .= "<hr>\n";
				}else{
					if($this->pd->getValue("show_shameless_plug")){
						$image = 	$this->pd->getValue("rss_pow_img");
						if($image_hr)$image .= "<hr>\n";
					}else{
						$image = "";
					}
				}
				//TODO: scrub $image to eliminate known bad images from default backend.php files
				$this->src->setImage($sd,$image);
		
				//Add Items
				$items = $channel["items"];
				$end = count($items);
				for($loop=$end;$loop>0;$loop--){
				//tarverse the rss items in reverse order to ensure the temporal integrity
					if($rss->MYH_DEBUG){
						$it = $items[$loop-1];
						echo "UC:  ( $loop / $end ) $it->title <br>\n";
					}
					$item = serialize($items[$loop-1]);
					$cid = $this->cache->saveItem($item,$sd);
				}
			}
		
			//delete expired items...
			$this->cache->flushCache($sd,$this->pd->getValue("rss_max_items"));	
		
		}
	}

	function refreshExpired(){
		$stale = $this->src->listStale();
		$end = count($stale);
		$breakout = 0;
		$output = "";
		@set_time_limit(480); //8 minutes
		$breakoutlimit=$this->pd->getValue("max_updates_per_cron_cycle");
		for($loop=0;$loop<$end;$loop++){
			$this->updateCache($stale[$loop]);
			$breakout++;
			$temp = $this->src->getTitle($stale[$loop]);
			$output .= "refreshExpired(): $breakout/$breakoutlimit/$end - $temp <br>\n";
			if($breakout>=$breakoutlimit)return;
		}
		$output .= "<p><a href=".$this->prefixURL." target=_blank>".$this->myhLang["Done"]."</a>\n";

		return $output;
	}	
	
	function userSubscriptionScreen(){
		$output = "<table width=100%><tr>";
		$output .= "<td valign=top width=25%>\n";
		$output .= $this->showBlocksVert("lt");
		$output .= "</td>";
		$output .= "<td valign=top width=50%>\n";
		$output .= $this->showBlocksVert("ct",1);
		$output .= "</td>";
		$output .= "<td valign=top width=25%>\n";
		$output .= $this->showBlocksVert("rt");
		$output .= "</td>";
		$output .= "</tr><tr><nobr>";
		$output .= "<td valign=top width=25%>\n";
		$output .= $this->showBlocksVert("lb");
		$output .= "</td>";
		$output .= "<td valign=top width=50%>\n";
		$output .= $this->showBlocksVert("cb",1);
		$output .= "</td>";
		$output .= "<td valign=top width=25%>\n";
		$output .= $this->showBlocksVert("rb");
		$output .= "</td>";
		$output .= "</tr></table></center>";
		return $output;
	}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Internal Utilities.
	function preProcessor(){
		global $myh;
		$restore_menu = 0;
		switch ($myh){
			case "user":
				$user = new myh_user($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$restore_menu = $user->preProcessing($this->pd,$this->gtu,$this->src,$this->stck,$this->act,$this->cache);
				break;
			case "admin":
				$admin = new myh_admin($this->pd,$this->cat,$this->src,$this->act,$this->stck,$this->myhLang,$this->prefixURL,$this->MYH_DEBUG);
				$restore_menu = $admin->preProcessing($this->pd,$this->gtu,$this->src,$this->stck,$this->act,$this->cat,$this->cache);
				break;
			default:
		}
		if($restore_menu)$this->restoreMenu();
	}

	function restoreMenu(){
		global $myh;
		$myh = "menu";
	}

	function getClickThruURL($cid){
		$url = $this->prefixURL."&myh=user&myh_op=click&cid=$cid";
		return $url;
	}

	function myhFormStart($myhState){
		global $meid,$eid,$pid,$tid,$gid,$context;
		$myh_form_start = "";
		if($this->MYH_DEBUG){
			$myh_form_start .= "<form action=\"".$this->prefixURL."\" method=\"get\">\n";
		}else{
			$myh_form_start .= "<form action=\"".$this->prefixURL."\" method=\"post\">\n";
		}
		$myh_form_start .= "
							<input type=\"hidden\" name=\"context\" value=\"$context\">\n 
							<input type=\"hidden\" name=\"gid\" value=\"$gid\">\n 
							<input type=\"hidden\" name=\"eid\" value=\"$eid\">\n 
							<input type=\"hidden\" name=\"tid\" value=\"$tid\">\n 
							<input type=\"hidden\" name=\"pid\" value=\"$pid\">\n
							<input type=\"hidden\" name=\"myh\" value=\"$myhState\">\n
							";
		if(isset($meid)){
			$myh_form_start .= "<input type=\"hidden\" name=\"meid\" value=\"$meid\">\n ";
		}
		
	
		return $myh_form_start;
	}
	
	function myhFormEnd($submit){
		$output = 	"
					<input type=\"submit\" value=\"$submit\">\n
					</form>\n
					";
		return $output;
	}

	function scrub($dirty){
		$clean = 		eregi_replace("\'","", $dirty); 
	//	$clean = 		eregi_replace("\"","", $clean); 
		return $clean;
	}
	
	function unscrub($clean){
		$dirty = urldecode($clean);
		$dirty = eregi_replace("&amp;","&", $dirty); 
		$dirty = eregi_replace("&lt;","<", $dirty); 
		$dirty = eregi_replace("&gt;",">", $dirty); 
		$dirty = eregi_replace("&quot;","\"", $dirty); 
		$dirty = eregi_replace("&apos;","\"", $dirty); 
		
		return $dirty;	
	}

	function myhResetButton($button){
		eval($this->pd->getValue("reset_button"));
		return $myh_form_start;
	}

	function configForm($what){
		$value = $this->pd->getValue($what);
		$output = "";
		$output .= "<p><table><tr><td valign=top width=100%>\n";
		$output .= $this->myhFormStart("admin");
		$output .= "$what";
		$output .= "</td><td valign=top>\n";
		$output .= "<input type=\"hidden\" name=\"myh_conf\" value=\"$what\">\n";
		$output .= "<input type=\"text\" width=80 name=\"myh_value\" value=\"$value\">\n";
		$output .= "<input type=\"hidden\" name=\"myh_op\" value=\"saveConfig\">\n";
		$output .= "</td><td valign=top>\n";
		$output .= $this->myhFormEnd($this->myhLang["Save"]);
		$output .="</td></table><hr>\n";
		return $output;
	}
	function dispBlock($box){
		$output = "<table border=1 width=100%><tr><td>";
		$output .= "<b><center>".$box["title"]."</center></b><hr>";	
		if(strlen($box["image"])>3){
			$output .= "<center>".$box["image"]."</center><hr>";	
		}
		$output .= $box["content"];	
		$output .= "</td></tr></table>";
		return $output;
	}
	
	function showBlocksVert($pos,$show_desc=0,$show_all=0){
		$output = "<table border=0 width=100%>";
		$subs = $this->getSubs($pos);
		$end = count($subs);
		for($loop=0;$loop<$end;$loop++){
			$sd = $subs[$loop];
			$output .= "<tr><td>";
			$this->updateCache($sd);
			$box = $this->getCache($sd,$show_desc,$show_all);
			$output .= $this->dispBlock($box);
			$output .= "</td></tr>";
		}
		$output .= "</table>";
		return $output;	
	}

	function doGoogleSearch($search,$start){
		$soapDebug = false;
		$max=(int)10;
		if($this->MYH_DEBUG||$soapDebug)echo "<p>Begin SOAP:";
		$query = array();
		$query["key"] = $this->pd->getValue("google_registration_key");
		if($soapDebug||$this->MYH_DBEUG)echo "Google Registration Key: ".$query["key"]."<br>";
		$query["q"] = $search;
		$query["start"] = (int)$start;
		$query["maxResults"] = $max;
		$query["filter"] = (boolean)true;
		$query["restrict"]="";
		$query["safeSearch"]=(boolean)false;
		$query["lr"]="";
		$query["ie"]="latin1";
		$query["oe"]="latin1";
		$soapclient = new soapclient("http://api.google.com/search/beta2");
		if($this->MYH_DEBUG||$soapDebug)$soapclient->debug_flag = true;
		$google_results = $soapclient->call("doGoogleSearch",$query,"urn:GoogleSearch","doGoogleSearch");
		if($this->MYH_DEBUG||$soapDebug)echo nl2br($soapclient->debug_data);
		if($soapDebug||$this->MYH_DBEUG){
			echo "<hr>Result: <br>";
			$this->renderArray($google_results,"google_results");
			echo "<hr>";
		}
		if($this->MYH_DEBUG||$soapDebug)echo "<p>End SOAP:<p>";
		////////////////Begin Drawing the Google Results/////////////////////
		if(is_array($google_results)){
			$outArray = array();
			$outArray["html"]="<table width=100% border=0>";
			$outArray["more"]=0;
			$end = count($google_results["resultElements"]);
			if($end==$max){
				$outArray["more"]=1;
			}
			
			for($loop=0;$loop<$end;$loop++){
				$hit = $google_results["resultElements"][$loop];
				$idx = $loop + $start;
				$outArray["html"].="<tr><td align=right valign=top>".$idx."&nbsp;-&nbsp;</td><td valign=top colspan=2><a target=new href=";
				$outArray["html"].=$hit["URL"];
				$outArray["html"].=">".$hit["title"]."</a></td></tr><tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
				$outArray["html"].="<td></td><td width=100% valign=top>".$hit["snippet"]."<br>&nbsp;</td></tr>";
			}
			$outArray["html"].="</table>";
		}else{
			$outArray = false;	
		}
		/////////////////////////////////////////////////////////////////////
		return $outArray;
	}

	function renderArray($arr,$name){
	//Handy little tool for displaying multi dimensional arrays
	//I found this really helped understand the results returned by Google's SOAP API
		if(is_array($arr)){
			$keys = array_keys($arr);
			$end = count($keys);
			for($loop=0;$loop<$end;$loop++){
				if(is_array($arr[$keys[$loop]])){
					$this->renderArray($arr[$keys[$loop]],$name."[".$keys[$loop]."]");
				}else{
					echo $name."[".$keys[$loop]."]"." = ".$arr[$keys[$loop]]."<br>";
				}
			}
		}else{
			echo "$name is not an array<br>";
		}
	}


	function uninstall(){
		//make sure the PD is populated with defaults
		$install = new myh_install;
		$install->UnInstall();		
	}
}
?>