<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 18, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
global $myhPath;
include_once("$myhPath/trees/user.php");
include_once("$myhPath/trees/category.php");
include_once("$myhPath/trees/menu.php");



class myh_admin {
	var $userTree;
	var $catTree;
	var $MYH_DEBUG;
	
	///////////////////////////////////////////////////////////////////
	// Constructor / INIT Functions
	function myh_admin($myh_pd,$myh_cat,$myh_src,$myh_act,$myh_stck,$myhLang,$url,$dbg=0){
		$this->MYH_DEBUG = $dbg;
		
		$this->userTree = new myh_user_tree($myh_pd,$dbg);
		$this->userTree->INIT_CALLBACK($myh_act,$myh_src,$myh_stck,$myhLang);
		$this->userTree->INIT_URL_PREFIX($url);

		$this->catTree = new myh_cat_tree($dbg);
		$this->catTree->INIT_CALLBACK($myh_cat,$myh_src);
		$this->catTree->INIT_URL_PREFIX($url);
	
	}

	///////////////////////////////////////////////////////////////////
	// Action Functions
	
	
	
	function updateHead($myh_pd,$myh_gtu,$myh_src){
		global  $myh_title, $myh_url, $myh_timeout, $myh_comment, $myh_dest, $eid;
		$tout = $myh_timeout * 3600;
		
		$myh_src->setURL($eid, $myh_url);
		$myh_src->setTitle($eid, $myh_title);
		$myh_src->setTimeout($eid, $tout);
		$myh_src->setComment($eid, $myh_comment);
		$this->catTree->goodSrc($myh_pd,$myh_gtu,$myh_src,$eid,1);
	}
	
	function deleteHead($myh_pd,$myh_gtu,$myh_src,$myh_cache,$allofthem=0){
		global $gid, $eid, $pid, $tid;
	
		if($this->MYH_DEBUG)echo "<b>deleteHead($allofthem):</b> ($gid,$pid,$eid,$tid)<br>\n";
	
		if($allofthem){
			//nuke this src off the face of the world...
			$myh_src->delSID($eid);
			$myh_cache->deleteAllItems($eid);
			$this->userTree->delAllUserSubscriptions($myh_gtu,$myh_src,$eid);
			$this->catTree->delAllHeadlineEntries($myh_gtu,$eid);
		}else{
			//just this one...
			$myh_gtu->delNode($gid,1);
		}
		$this->catTree->resetPathArray($myh_pd);
	}
	
	
	function saveHead($myh_gtu,$myh_src){
		global $myh_title, $myh_url, $myh_timeout, $myh_comment, $myh_dest;
		$tout = $myh_timeout * 3600;
		$this->catTree->addHeadlineSrc($myh_gtu,$myh_src,$myh_title,$myh_url,$myh_comment,$tout,$myh_dest);
	}
	
	function saveConfig($myh_pd){
		global $myh_conf, $myh_value;
		$myh_pd->setValue($myh_conf, $myh_value);
		//unset all trees just in case we have a language change
		$myh_pd->setValue("menu_initialized",0);
		$myh_pd->setValue("user_show_1",0);
		$myh_pd->setValue("user_show_adm",0);
		$myh_pd->setValue("cat_show_1",0);
		$myh_pd->setValue("cat_show_2",0);
				
	}
	
	function saveCat($myh_pd,$myh_gtu,$myh_cat){
		global $myh_title, $myh_dest;
		$pid = $this->catTree->addCat($myh_gtu,$myh_cat,$myh_title,$myh_dest);
		$this->catTree->resetPathArray($myh_pd);
	}

	function renameCat($myh_pd,$myh_gtu,$myh_cat){
		global $myh_title, $myh_dest, $gid;
		$pid = $this->catTree->renameCat($myh_gtu,$myh_cat,$myh_title,$gid);
		$this->catTree->resetPathArray($myh_pd);
	}

	function completeCopy($myh_pd,$myh_gtu){
		global $myh_dest, $gid;
		$myh_gtu->copyNode($gid,$myh_dest,1);
		$this->catTree->resetPathArray($myh_pd);
	}

	function myhNewStock($myh_pd,$myh_gtu,$myh_act,$myh_stck){
		global $stckAlias, $stckSymbol;
	
		$to = 60 * $myh_pd->getValue("stck_timeout");
		if($to<1200){
			$to=1200; //nothing less than 20 minutes...
			$myh_pd->setValue("stck_timeout",20);
		}
		$sd = $myh_stck->addSTCK($stckAlias,$stckSymbol,$to);
		$this->userTree->addStock($myh_gtu,$myh_act,$myh_stck,$sd,1);
	}
	

	///////////////////////////////////////////////////////////////////
	// Flow Functions

	function preProcessing($myh_pd,$myh_gtu,$myh_src,$myh_stck,$myh_act,$myh_cat,$myh_cache){
		global $eid,$meid,$myh_op, $myh_title, $myh_url, $myh_allofthem;
		global $myh_plc,$gid;
		
		//test for admin
		if(!$myh_act->isAdmin){
			die("Goodbye.");
		}
		$restoreMenu = 0;
		if($this->MYH_DEBUG)echo "adminPreProcessing(): op = $myh_op<br>\n";
		
		switch($myh_op){
			case "new_stock":
				if($this->MYH_DEBUG)echo "adminPreProcessing(): new_stock: adding your stock.<br>\n";
				$this->myhNewStock($myh_pd,$myh_gtu,$myh_act,$myh_stck);
				$restoreMenu = 1;
				break;
			case "saveConfig":
				if($this->MYH_DEBUG)echo "<hr>Save Config: $myh_conf, $myh_value<hr>";
				$this->saveConfig($myh_pd);
				$restoreMenu = 1;
				break;
			case "renameCat":
				if($this->MYH_DEBUG)echo "<hr>Rename Category: $myh_title, $myh_dest<hr>";
				$this->renameCat($myh_pd,$myh_gtu,$myh_cat);
				$restoreMenu = 1;
				break;
			case "saveCat":
				if($this->MYH_DEBUG)echo "<hr>Save Category: $myh_title, $myh_dest<hr>";
				$this->saveCat($myh_pd,$myh_gtu,$myh_cat);
				$restoreMenu = 1;
				break;
			case "saveHead":
				if($this->MYH_DEBUG)echo "<hr>Save Headline: $myh_title, $myh_url<hr>";
				$this->saveHead($myh_gtu,$myh_src);
				$restoreMenu = 1;
				break;
			case "copy2":
				if($this->MYH_DEBUG)echo "<hr>Copy2:<hr>";
				$this->completeCopy($myh_pd,$myh_gtu);
				$restoreMenu = 1;
				break;
			case "updateHead":
				if($this->MYH_DEBUG)echo "<hr>Update Headline: $myh_title, $myh_url<hr>";
				$this->updateHead($myh_pd,$myh_gtu,$myh_src);
				$restoreMenu = 1;
				break;
			case "deleteHead":
				if($this->MYH_DEBUG)echo "<hr>Delete Headline: $myh_title, $myh_url<hr>";
				$this->deleteHead($myh_pd,$myh_gtu,$myh_src,$myh_cache,$myh_allofthem);
				$restoreMenu = 1;
				break;
			case "del1":
				if($this->MYH_DEBUG)echo "<hr>Delete Headline: $myh_title, $myh_url<hr>";
				$this->deleteHead($myh_pd,$myh_gtu,$myh_src,$myh_cache,0);
				$restoreMenu = 1;
				break;
			case "sub2":
				if($this->MYH_DEBUG)echo "adminPreProcessing(): sub2: adding ($eid) to your default site subscriptions<br>\n";
				$this->userTree->addSubscription($myh_gtu,$myh_act,$myh_src,$myh_plc,1);
				$restoreMenu = 1;
				break;
			case "cancel":
				$restoreMenu = 1;
				break;
			default:
				break;
		}
		
		return $restoreMenu;
	}

	function getScreenCode(){
		global $myh_op,$myhPath;
		
		if($this->MYH_DEBUG)echo "admin - getScreenCode(): myh_op = $myh_op<br>\n";
		//New - No more case statement.  Now just the file names!!!
		$fname = array();	
		$fname["confNewHead"] = $myhPath."/screens/admConfNewSrc.php";
		$fname["newHead"]     = $myhPath."/screens/admNewSrc.php";
		$fname["newCat"]      = $myhPath."/screens/admNewCat.php";
		$fname["copy1"]       = $myhPath."/screens/admCopy.php";
		$fname["rename"]      = $myhPath."/screens/admRename.php";
		$fname["newStckSub"]  = $myhPath."/screens/admNewStock.php";
		$fname["defSub"]      = $myhPath."/screens/admConfSubscribe.php";
		$fname["ut_del"]      = $myhPath."/screens/admUT_Delete.php";
		$fname["info"]        = $myhPath."/screens/admSrcInfo.php";
		$fname["test1"]       = $myhPath."/screens/admVerifySrc.php";
		$fname["edit1"]       = $myhPath."/screens/admVerifySrc.php";

		if($this->MYH_DEBUG) echo "admin - getScreenCode(): File = ".$fname[$myh_op]."<hr><br>\n";

		$fd = fopen ($fname[$myh_op], "r");
		$contents = fread ($fd, filesize ($fname[$myh_op]));
		fclose ($fd);
		return $contents;
	}
}
?>