<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 15, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////

/********************************
Channel definition
~~~~~~~~~~~~~~~~~~
channel["title"]				=source title/name
channel["link"]					=link to the source site
channel["description"]	=descript of this channel's content/purpose
channel["image"]				=site logo/image/banner
channel["items"]				=an ARRAY of RSS_ITEM's (see below) NOTE 
*/

class RSS_ITEM {
	var $title;				//headline
	var $link;				//link to story
	var $description;	//synopsis of story
//	var $stamp; //time stamp of when recieved
}

class myh_rss {
	///////////////////////////////////////////////////////////////////
	// Connection and Download Functions
	var $MYH_DEBUG;
	
	function myh_rss($myh_pd,$dbg=0){
		global $myhPath;
		$this->MYH_DEBUG = $dbg;	
		if(!$myh_pd->getValue("rss_initialized")){
			//init rss
			if($this->MYH_DEBUG)echo "RSS: Initializing RSS Defaults<br>\n";
			$myh_pd->setValue("rss_initialized",1);
			$myh_pd->setValue("rss_timeout",5);
			$myh_pd->setValue("rss_proxy_enabled",0);
			$myh_pd->setValue("rss_max_items",6);
			$myh_pd->setValue("rss_show_summary",0);
			$myh_pd->setValue("rss_logo_width",120);
			$myh_pd->setValue("rss_override_logo_width",1);
			$myh_pd->setValue("rss_cache_expire","30");//days
			$myh_pd->setValue("rss_pow_img","<a href=http://www.jmagar.com><img alt=MyHeadlines src=$myhPath/images/myh.gif border=0></a>");
		}

	}
	
	function rssConnect($myh_pd,$url,$timeout)
	{
	############################################################################################################
	## Credit to Pim van der Zwet (pim@zwet.com) for the original PROXY Code.  I have made some mods
	## to fit MyHeadlines better... 
	############################################################################################################		
		$rss = parse_url($url);
		$use_proxy = $myh_pd->getValue("rss_proxy_enabled");
		if($use_proxy) {
			$rss["proxy_host"]=$myh_pd->getValue("rss_proxy_host");
			$rss["proxy_port"]=$myh_pd->getValue("rss_proxy_port");
			$rss["proxy_user"]=$myh_pd->getValue("rss_proxy_user");
			$rss["proxy_pass"]=$myh_pd->getValue("rss_proxy_pass");
		  $fp = fsockopen($rss["proxy_host"], $rss["proxy_port"], $errno, $errstr, $timeout);
		}else{
			$rss["port"] = ($rss["port"])?$rss["port"]:80;
		  $fp = fsockopen($rss["host"], $rss["port"], $errno, $errstr, $timeout);
		}
	
		if(!$fp) {
			if($this->MYH_DEBUG)echo "Couldn't connect to $url,  ($errno, $errstr)<br>\n";
		}
		else
		{
	    if($use_proxy){
			//proxy
				if($this->MYH_DEBUG)echo "Connecting through the Proxy  ($errno, $errstr)<br>\n";
				$str = "";
				$str.="GET $url HTTP/1.0 \r\n";
			  if($rss["proxy_user"])$str.="Proxy-Authorization: Basic ".base64_encode($rss["proxy_user"].":".$rss["proxy_pass"]) ."\r\n"; 
			}else{
			//normal
				if($this->MYH_DEBUG)echo "Connecting Directly  ($errno, $errstr)<br>\n";
				$str = "";
				$url = $rss[path];
				if($rss[query]) $url .= '?'.$rss[query];	
				$str.="GET $url HTTP/1.0 \r\n";
				$str.="Host: ".$rss["host"]."\r\n";
			}
			if($rss["user"]){
				//authentication is on		
				if($this->MYH_DEBUG)echo "Adding User Account Info  ($errno, $errstr)<br>\n";
				$str .= "Authorization: Basic "; 
				$str .= base64_encode("$rss[user]:$rss[pass]") . "\r\n";
			}
			$str.="Connection: close\r\n\r\n";
			fputs($fp, $str);
		}
		return $fp;
	}
	
	function getRSS($myh_pd,$url){
		$timeout = $myh_pd->getValue("rss_timeout");
		$start = time(); $page="";
		$fp = myh_rss::rssConnect($myh_pd,$url,$timeout);
		if(!$fp)return 0;
		while(!feof($fp)){
			$page.= fread($fp,256);
			$duration = time()-$start;
			if(	$duration > $timeout) return 0;	
		}
		return $page;
	}
	
	function getFileFromURL($myh_pd,$url){
		return myh_rss::getRSS($myh_pd,$url);
	}
	
	function rssParsePage($rss_file){
	##################################################################################
	# Modified to meet MyHeadlines needs... 
	# I took this from Post Nuke & Pim van der Zwet (pim@zwet.com)
	# Ripped the example from: http://zend.com/codex.php?id=644&single=1
	# Original author: goliche@goliche.org <goliche@goliche.org>
	# Uses regular expressions to parse the XML file (no support for old style yet)
	##################################################################################
	//TODO: use a ezxml class to parse this and other formats... (www.zez.org)	
		$rss_array = array();
		$content = array();
		
		$searchfile = eregi("<channel>(.*)</channel>", $rss_file ,$arrayreg); 
		eregi("<title>(.*)</title>",$arrayreg[0], $title); 
		eregi("<link>(.*)</link>",$arrayreg[0], $link); 
		eregi("<description>(.*)</description>",$arrayreg[0], $description); 
		$channel["title"] = eregi_replace("</title>.*","",$title[1]);
		$channel["link"] = eregi_replace("</link>.*","",$link[1]);
		$channel["description"] = eregi_replace("</description>.*","",$description[1]);
		$searchfile = eregi("<image>(.*)</image>", $rss_file ,$arrayreg); 
		eregi("<url>(.*)</url>",$arrayreg[0], $url);
		$channel["image"] = $url[1];
		
	
		$searchfile = eregi("<item>(.*)</item>", $rss_file ,$arrayreg); 
		$filechunks = explode("<item>", $arrayreg[0]); 
		$count = count($filechunks); 
		for($i=1 ; $i<$count ;$i++) 
		{ 
			$title = $description = $links = 0;
			eregi("<title>(.*)</title>",$filechunks[$i], $title); 
			eregi("<link>(.*)</link>",$filechunks[$i], $links); 
			eregi("<description>(.*)</description>",$filechunks[$i], $description);
			$item = new RSS_ITEM;
			$item->title = myh_rss::scrub(eregi_replace("</title>.*","",$title[1]));
			$item->description = myh_rss::scrub(eregi_replace("</description>.*","",$description[1]));
			$item->link = eregi_replace("</link>.*","",$links[1]);
			$rss_array[] = $item;
		} 
		$channel["items"]=$rss_array;
		return $channel;
	}
	
	function unscrub($clean){
		$dirty = urldecode($clean);
		$dirty = eregi_replace("&amp;","&", $dirty); 
		$dirty = eregi_replace("&apos;","", $dirty); 
		$dirty = eregi_replace("&lt;","<", $dirty); 
		$dirty = eregi_replace("&gt;",">", $dirty); 
		$dirty = eregi_replace("&quot;","\"", $dirty); 
		
		return $dirty;	
	}

	
	function scrub($input){
		return $input;
	}
	
	function previewChannel($channel){
		$output =  "$channel[title]<br>\n";
		if(strlen($channel["link"])>4)$output .=  "<a href=".$channel["link"]." target=_blank>".$channel["link"]."</a><br>\n";
		$output .= $channel["description"]."<br>\n";
		if(strlen($channel["image"])>4)$output .= "<img src=".$channel["image"]."><br>\n";
		$output .= "<br><ul>\n";
		$items = $channel["items"];
		$end = count($items);
		for($loop=0;$loop<$end;$loop++){
			$item = $items[$loop];
			$output .= "<a href=$item->link target=_blank>$item->title</a><br>\n";
			if(strlen($item->description)>4)$output .= "<ul>$item->description</ul><br>\n";	
		}
		$output .= "</ul>\n";	
		return $output;
	}
}
?>