<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.0, March 18, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
global $myhPath;
include_once("$myhPath/trees/user.php");
include_once("$myhPath/trees/category.php");
include_once("$myhPath/trees/menu.php");


class myh_user {
	var $userTree;
	var $catTree;
	var $MYH_DEBUG;
	
	///////////////////////////////////////////////////////////////////
	// Constructor / INIT Functions
	function myh_user($myh_pd,$myh_cat,$myh_src,$myh_act,$myh_stck,$myhLang,$url,$dbg=0){
		$this->MYH_DEBUG = $dbg;
		
		$this->userTree = new myh_user_tree($myh_pd,$dbg);
		$this->userTree->INIT_CALLBACK($myh_act,$myh_src,$myh_stck,$myhLang);
		$this->userTree->INIT_URL_PREFIX($url);

		$this->catTree = new myh_cat_tree($dbg);
		$this->catTree->INIT_CALLBACK($myh_cat,$myh_src);
		$this->catTree->INIT_URL_PREFIX($url);
	
	}
	
	function myhNewStock($myh_pd,$myh_gtu,$myh_act,$myh_stck){
		global $stckAlias, $stckSymbol;
	
		$to = 60 * $myh_pd->getValue("stck_timeout");
		if($to<1200){
			$to=1200; //nothing less than 20 minutes...
			$myh_pd->setValue("stck_timeout",20);
		}
		$sd = $myh_stck->addSTCK($stckAlias,$stckSymbol,$to);
		$this->userTree->addStock($myh_gtu,$myh_act,$myh_stck,$sd);
	}

	function myhSubmission($myh_gtu,$myh_src){
		global $myh_title, $myh_url, $myh_timeout, $myh_comment, $myh_dest;
	
		if($this->MYH_DEBUG)echo "myhSummision(): title = $myh_title<br>\n";
		if($this->MYH_DEBUG)echo "myhSummision(): url = $myh_url<br>\n";
		if($this->MYH_DEBUG)echo "myhSummision(): timeout = $myh_timeout<br>\n";
		if($this->MYH_DEBUG)echo "myhSummision(): comment = $myh_comment<br>\n";
		if($this->MYH_DEBUG)echo "myhSummision(): dest = $myh_dest<br>\n";
		$tout = $myh_timeout * 3600;
		$this->catTree->addUserHeadlineSrc($myh_gtu,$myh_src,$myh_title,$myh_url,$myh_comment,$tout,$myh_dest);
		
		return;
	}

	function clickThru($myh_pd,$myh_cache){
		global $cid;
		$item = unserialize($myh_cache->getItem($cid));
		$hits = $myh_cache->incHits($cid);
		$redirect = "Location: ".myh_rss::unscrub($item->link);
		header($redirect);	
	}

	///////////////////////////////////////////////////////////////////
	// Flow Functions
	
	function preProcessing($myh_pd,$myh_gtu,$myh_src,$myh_stck,$myh_act,$myh_cache){
		global $eid,$meid,$myh_op,$myh_plc,$gid;

		$restore_menu = 0;
		if($this->MYH_DEBUG)echo "userPreProcessing(): op = $myh_op<br>\n";
		
		switch($myh_op){
			case "new_stock":
				if($this->MYH_DEBUG)echo "userPreProcessing(): new_stock: adding your stock.<br>\n";
				$this->myhNewStock($myh_pd,$myh_gtu,$myh_act,$myh_stck);
				$restore_menu = 1;
				break;
			case "submit":
				if($this->MYH_DEBUG)echo "userPreProcessing(): submit: adding your suggested source.<br>\n";
				$this->myhSubmission($myh_gtu,$myh_src);
				break;
			case "del_stock":
				if($this->MYH_DEBUG)echo "userPreProcessing(): unsub: deleting ($eid) from your subscriptions<br>\n";
				$this->userTree->delStockSubscription($myh_gtu);
				$restore_menu = 1;
				break;
			case "unsub":
				if($this->MYH_DEBUG)echo "userPreProcessing(): unsub: deleting ($eid) from your subscriptions<br>\n";
				$this->userTree->delSubscription($myh_gtu,$myh_src);
				$restore_menu = 1;
				break;
			case "sub2":
				if($this->MYH_DEBUG)echo "userPreProcessing(): sub2: adding ($eid) to your subscriptions<br>\n";
				$this->userTree->addSubscription($myh_gtu,$myh_act,$myh_src,$myh_plc);
				$restore_menu = 1;
				break;
			case "cancel":
				$restore_menu = 1;
				break;				
			case "click":
				if($this->MYH_DEBUG)echo "userPreProcessing(): click: Doing click thru...<br>\n";
				$this->clickThru($myh_pd,$myh_cache);
				break;
			default:
				break;
		}
		
		return $restore_menu;
	}


	function getScreenCode(){
		global $eid,$meid,$myh_op, $myhPath;
		
		switch($myh_op){
			case "new_stock":
			case "del_stock":
				$fname  = "$myhPath/screens/usrDone.php";
				break;
			case "show_all":
				$fname  = "$myhPath/screens/usrShowAll.php";
				break;
			case "latest":
				$fname  = "$myhPath/screens/usrRecent.php";
				break;
			case "search":
				$fname  = "$myhPath/screens/usrSearchResults.php";
				break;
			case "submit":
				$fname  = "$myhPath/screens/usrThanks.php";
				break;
			case "sub1":
				//preview and confirm
				$fname  = "$myhPath/screens/usrConfSubscribe.php";
				break;
			default:
				echo "unknown op = $myh_op <br>\n";
				$fname  = "$myhPath/screens/usrDone.php";
				break;
			
		}
		$fd = fopen ($fname, "r");
		$contents = fread ($fd, filesize ($fname));
		fclose ($fd);
		return $contents;

	}
}
?>